#include <stdio.h>
#include <time.h>
#include "gtall.h"

#define NMAX	50
#define NMIN	-50

GtApp *app;
GtDisplay *dsp;
GtAppShell *shell;
GtMenu *fmenu,*omenu;
GtProgBar *pb;
GtNumber *num;
GtScroller *scr;
GtGroup *grp;
GtMenuBar *mbar;
GtDialog *dia;
GtFileReq *freq;
GtGroup *grps[2];

char *names[]={"toggle","radiobuttons",NULL};

int nr=0;

int QuitCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	obj=obj;
	cd=cd;
	ud=ud;
	app->BreakLoop();
	return(GTCB_CONT);
}

int IncDecCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	int d;
	
	obj=obj;
	cd=cd;
	d=(int)ud;
	nr+=d;
	if(nr<NMIN)
		nr=NMIN;
	if(nr>NMAX)
		nr=NMAX;
	num->SetV(GT_Number,nr,GT_DONE);
	pb->SetV(GT_Value,nr,GT_DONE);
	scr->SetV(GT_Value,nr,GT_DONE);
	return(GTCB_CONT);
}

int ScrCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtScrollerCD *scd;
	
	obj=obj;
	scd=(GtScrollerCD *)cd;
	ud=ud;
	nr=scd->value;
	num->SetV(GT_Number,nr,GT_DONE);
	pb->SetV(GT_Value,nr,GT_DONE);
	return(GTCB_CONT);
}

int LoadCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	long xp,yp,xs,ys,xs2,ys2;
	
	obj=obj;
	cd=cd;
	ud=ud;
	freq->SetV(GT_LoadSave,TRUE,GT_DONE);
	dia->Show();
	freq->Activate();
	return(GTCB_CONT);
}

int SaveCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	long xp,yp,xs,ys,xs2,ys2;
	
	obj=obj;
	cd=cd;
	ud=ud;
	freq->SetV(GT_LoadSave,FALSE,GT_DONE);
	dia->Show();
	freq->Activate();
	return(GTCB_CONT);
}

int HideDiaCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	obj=obj;
	cd=cd;
	ud=ud;
	dia->Hide();
	return(GTCB_CONT);
}

int CycleChg(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtCycleCD *ccd;
	
	obj=obj;
	ccd=(GtCycleCD *)cd;
	ud=ud;
	grps[ccd->nr]->Map(TRUE);
	return(GTCB_CONT);
}

void Setup(int *argc,char **argv)
{
	app=GtMkApp(GT_AppName,"tstw",GT_AppClass,"TstW",GT_DONE);
	app->SetupRes(argc,argv);
	dsp=GtMkAppDisp(app,NULL);
	shell=GtMkAppShell("shell",(GtManager *)dsp,NULL);
	shell->AddCB(GT_Close,QuitCB,NULL);
	grp=GtMkGroup("vgrp1",shell,
		GT_Orient,GTO_VERT,
		GT_DONE);
}

void InitMenus(void)
{
	GtMenu *m;
	GtGroup *g;
	GtRadioGroup *rg;
	GtButton *b;
	GtToggle *t;
	GtCascade *c;
	
	mbar=GtMkMenuBar("mbar",grp,
		GT_Orient,GTO_HORIZ,
		GT_FrameType,GTF_OUT,
		GT_Weight,0,
		GT_DONE);
	fmenu=GtMkMenu("fmenu",mbar,GT_Mapped,FALSE,GT_DONE);
	g=GtMkGroup("fgrp",fmenu,
		GT_FrameType,GTF_OUT,
		GT_Orient,GTO_VERT,
		GT_DONE);
	b=GtMkButton("abut",g,NULL);
	GtMkLabel("about",b,NULL);
	GtMkSeparator("sep",g,GT_BAll,2,GT_DONE);
	b=GtMkButton("qbut",g,NULL);
	b->AddCB(GT_Activate,QuitCB,NULL);
	GtMkLabel("quit",b,NULL);
	omenu=GtMkMenu("omenu",mbar,GT_Mapped,FALSE,GT_DONE);
	rg=GtMkRadioGroup("ogrp",omenu,
		GT_FrameType,GTF_OUT,
		GT_Orient,GTO_VERT,
		GT_DONE);
	m=GtMkMenu("osmenu",omenu,GT_Mapped,FALSE,GT_DONE);
	g=GtMkGroup("osgrp",m,
		GT_FrameType,GTF_OUT,
		GT_Orient,GTO_VERT,
		GT_DONE);
	b=GtMkButton("lbut",g,NULL);
	GtMkLabel("load",b,NULL);
	b->AddCB(GT_Activate,LoadCB,NULL);
	b=GtMkButton("sbut",g,NULL);
	GtMkLabel("save",b,NULL);
	b->AddCB(GT_Activate,SaveCB,NULL);
	c=GtMkCascade("casc",rg,GT_Menu,m,GT_DONE);
	GtMkLabel("disk",c,NULL);
	t=GtMkToggle("o1but",rg,NULL);
	GtMkLabel("opt1",t,NULL);
	t=GtMkToggle("o2but",rg,NULL);
	GtMkLabel("opt2",t,NULL);
	dia=GtMkDialog("filereq",shell,GT_Mapped,FALSE,GT_Block,TRUE,GT_DONE);
	dia->AddCB(GT_Close,HideDiaCB,NULL);
	freq=GtMkFileReq("freq",dia,NULL);
	freq->AddCB(GT_Done,HideDiaCB,NULL);
}

void InitShell(void)
{
	GtGroup *g,*g2,*g3;
	GtCascade *c;
	GtButton *b;
	GtFrame *f;
	GtCycle *cy;
	GtList *l;
	GtToggle *t;
	GtLayer *ly;
	GtStrInput *si;
	GtScrList *sl;
	GtColormap *cm=NULL;
	XColor red;
	
	shell->GetV(GT_Colormap,&cm,GT_DONE);
	cm->AllocNamedC("Red",&red);
	c=GtMkCascade("fcasc",mbar,
		GT_Direction,GTD_DOWN,
		GT_Menu,fmenu,
		GT_BAll,1,
		GT_Weight,0,
		GT_DONE);
	GtMkLabel("file",c,NULL);
	c=GtMkCascade("ocasc",mbar,
		GT_Direction,GTD_DOWN,
		GT_Menu,omenu,
		GT_BAll,1,
		GT_Weight,0,
		GT_DONE);
	GtMkLabel("options",c,NULL);
	g=GtMkGroup("hgrp1",grp,
		GT_Orient,GTO_HORIZ,
		GT_DONE);
	f=GtMkFrame("frm",g,
		GT_BAll,2,
		GT_DONE);
	GtMkLabel("value",f,GT_BAll,1,GT_FrameTitle,TRUE,GT_DONE);
	g2=GtMkGroup("vgrp2",f,
		GT_Orient,GTO_VERT,
		GT_DONE);
	g3=GtMkGroup("hgrp2",g2,
		GT_Orient,GTO_HORIZ,
		GT_DONE);
	b=GtMkButton("dbut",g3,
		GT_BAll,2,
		GT_DONE);
	b->AddCB(GT_Activate,IncDecCB,(GtUDPtr)-1);
	GtMkLabel("dec",b,NULL);
	GtMkSpace("space",g3,NULL);
	b=GtMkButton("ibut",g3,
		GT_BAll,2,
		GT_ButtonMask,Button1Mask|Button2Mask,
		GT_DONE);
	b->AddCB(GT_Activate,IncDecCB,(GtUDPtr)1);
	GtMkLabel("inc",b,NULL);
	num=GtMkNumber("num",g3,
		GT_Place,GTP_CENTER,
		GT_BAll,2,
		GT_Number,0,
		GT_DONE);
	pb=GtMkProgBar("prog",g2,
		GT_Orient,GTO_HORIZ,
		GT_Start,NMIN,
		GT_End,NMAX,
		GT_Value,0,
		GT_BAll,2,
		GT_DONE);
	g3=GtMkGroup("sgrp",g2,
		GT_Orient,GTO_HORIZ,
		GT_BAll,2,
		GT_DONE);
	b=GtMkButton("al",g3,
		GT_Repeat,TRUE,
		GT_Delay,50,
		GT_InitialDelay,50,
		GT_DONE);
	b->AddCB(GT_Activate,IncDecCB,(GtUDPtr)-1);
	GtMkSymbol("als",b,
		GT_Symbol,GTST_CARROW,
		GT_Direction,GTD_LEFT,
		GT_DONE);
	scr=GtMkScroller("scr",g3,
		GT_Orient,GTO_HORIZ,
		GT_Start,NMIN,
		GT_End,NMAX,
		GT_Value,0,
		GT_Page,10,
		GT_ReportDrag,TRUE,
		GT_DONE);
	scr->AddCB(GT_ValueChange,ScrCB,NULL);
	b=GtMkButton("ar",g3,
		GT_Repeat,TRUE,
		GT_Delay,50,
		GT_InitialDelay,50,
		GT_DONE);
	b->AddCB(GT_Activate,IncDecCB,(GtUDPtr)1);
	GtMkSymbol("ars",b,
		GT_Symbol,GTST_CARROW,
		GT_Direction,GTD_RIGHT,
		GT_DONE);
	g2=GtMkGroup("vgrp3",g,
		GT_Orient,GTO_VERT,
		GT_BAll,2,
		GT_DONE);
	cy=GtMkCycle("cycle",g2,
		GT_LabelNames,names,
		GT_Place,GTP_CENTER,
		GT_DONE);
	cy->AddCB(GT_Activate,CycleChg,NULL);
	ly=GtMkLayer("layer",g2,NULL);
	grps[0]=GtMkGroup("vgrp4",ly,
		GT_Orient,GTO_VERT,
		GT_BAll,2,
		GT_DONE);
	t=GtMkToggle("tg1",grps[0],NULL);
	GtMkLabel("toggle1",t,NULL);
	t=GtMkToggle("tg2",grps[0],NULL);
	GtMkLabel("toggle2",t,NULL);
	grps[1]=GtMkRadioGroup("vgrp5",ly,
		GT_Orient,GTO_VERT,
		GT_BAll,2,
		GT_Mapped,FALSE,
		GT_DONE);
	t=GtMkToggle("tg1",grps[1],NULL);
	GtMkLabel("radio1",t,NULL);
	t=GtMkToggle("tg2",grps[1],NULL);
	GtMkLabel("radio2",t,NULL);
	t=GtMkToggle("tg3",grps[1],NULL);
	GtMkLabel("radio3",t,NULL);	
	g2=GtMkGroup("vgrp6",g,
		GT_Orient,GTO_VERT,
		GT_BAll,2,
		GT_DONE);
	si=GtMkStrInput("str",g2,
		GT_String,"Hello!",
		GT_MaxLength,80,
		GT_BAll,2,
		GT_Weight,0,
		GT_DONE);
	sl=GtMkScrList("list",g2,NULL);
	sl->GetGroup()->SetV(GT_BAll,2,GT_DONE);
	l=sl->GetList();
	l->SetV(GT_Mode,GTLM_ALWAYSONE,GT_DONE);
	l->AddItem("Hello!",GTP_LAST);
	l->AddItem("World!",GTP_LAST);
	l->AddItem("------",1);
	l->AddItem("Gran",GTP_LAST,red.pixel);
	l->AddItem("Gustafsson",GTP_LAST);
}

int main(int argc,char **argv)
{
	int n=0;
	time_t st,et;
	
	Setup(&argc,argv);
	InitMenus();
	InitShell();
	shell->Build();
	app->EventLoop(GTAM_LOOP);
	GtDestroy(app);
/*
	st=time(NULL);
	while(app->EventLoop(GTAM_POLL))
		n++;
	et=time(NULL);
	printf("Polled %d times in %d secs\n",n,et-st);
*/
	return(0);
}
